==========================================
PRU SOFTWARE SUPPORT PACKAGE RELEASE NOTES
==========================================

The PRU Software Support Package (PSSP) is not updated on a set schedule.
However, when TI updates the PSSP, we group commits by tag. Specific tags of
the PSSP are available for download here:
https://git.ti.com/cgit/pru-software-support-package/pru-software-support-package/

Release Notes for each tag are below. For additional details, reference the
individual commit messages.
e.g.,
$ git log --oneline
copy the git hash of the commit you are interested in
$ git show gitHash

v6.4.0
------
Released 2024-04-15

This release fixes some errors in the PRU UART registers for K3 devices:
include/am62x/pru_uart.h
include/am64x/pru_uart.h
include/am65x/pru_uart.h

It also adds PRU UART example
examples/am62x/PRU_Hardware_UART

SORTE_G: add support for 200 Bytes/device, fix several bugs

v6.3.0
------
Released 2023-11-21

This release adds resources for using AM243x & AM64x PRU cores with cores
running FreeRTOS:
 * The RTOS Getting Started Labs
 * Examples for using PRU GPIO and the broadside interface
 * SORTE_G example (a custom networking interface)

Bug fixes:
 * AM64x & AM65x header files, fix the names of extended sections to be in the
   format of
   ConstantsTableName_0x100

v6.2.0
------
Released 2023-06-29

This release supports Linux kernel 6.1. The RPMsg library in previous versions
of the PSSP will not work with the PRU RPMsg drivers in Linux kernel 6.1.

Other changes:
 * Bug fixes:
     - Getting Started Labs, fix "zero" command clearing too many bytes
     - Include files, add a missing parentheses to pru_cfg, pru_ctrl, pru_ecap
 * Update ReadMe files to point to the latest URLs
 * Create the folder structure for AM243x projects

v6.1.0
------
Released 2022-04-07

This release adds AM62x support to the PSSP. AM62x PRU is compatible with Linux
kernel 5.10 and later.
 * include/am62x (header files)
 * examples/am62x (Halt, Direct_Connect, MAC_Multiply_Accum, RPMsg)
 * labs/Getting_Started_Labs & labs/Hands_on_Labs/lab_5

Other changes:
 * Remove the "Protect" section from PRU Constant Table entries. Affected the
     linker command files for ICSSG devices (AM64x, AM65x, J7). Also applies to
     ICSSM v2.3 devices (which start with AM62x & AM263x).
 * If the "Protect" PRU Constant Table entry is reserved, then the reserved
     section must be less than 0x200. Reduce the arbitrary reserved section
     lengths in the linker command files for AM64x, AM65x, J7.
 * examples/j7: in TX_PRU linker command files, change PRU0/1_CTRL to
     TX_PRU0/1_CTRL. TI does NOT currently support PRU development on J7.


v6.0.1
------
Released 2021-11-24

Bugfix on top of v6.0.0.
PRU_Direct_Connect0 for PRU_ICSSG devices was disabling
interrupts instead of clearing the status of interrupts. Fix AM64x & AM65x by
writing to ICSS_INTC_ENA_STATUS_REGx instead of ICSS_INTC_ENABLE_CLR_REGx.


v6.0.0
------
Released 2021-10-17

This release supports Linux kernel 5.10 RemoteProc driver:
 * Port include/pru_types to be Linux kernel 5.10 compatible. Breaks kernel 5.4
     compatibility. Use PSSP v5.9.0 or earlier for Linux kernel 5.4.
 * Port existing projects in examples/ and labs/ to be compatible with
     Linux kernel 5.10. Applies to AM335x, AM437x, AM57xx, AM65x, K2G, J7ES1.

Add AM64x support. AM64x PRU is compatible with Linux kernel 5.10 and later.
 * include/am64x (header files)
 * examples/am64x (Halt, Direct_Connect, MAC_Multiply_Accum, RPMsg)
 * labs/Getting_Started_Labs & labs/Hands_on_Labs/lab_5

J721E PRU development is not supported by TI at the time of this tag. J721E
projects were ported to Linux 5.10 to enable community members who want to
develop J721E PRU without TI support.

K2G PRU development is only supported by TI up through the latest K2G Processor
SDK release (SDK 6.3, Linux kernel 4.19 at the time of this tag). Thus, K2G was
removed from the labs in v6.0.0. Other K2G projects were ported to Linux 5.10 to
enable community members who want to develop K2G PRU without TI support.

Update Direct_Connect examples:
 * Show how to pass INTC configuration to the Linux 5.10 RemoteProc driver
 * Add additional comments for how to pass interrupts and data between PRU cores
 * Add ReadMe.txt with FAQs about testing the example in Linux and loading the
   example from CCS or a non-Linux core.
 * Update am335x, am437x, am572x, k2g projects
 * Add projects for am64x, am65x

Other changes:
 * examples/<processor>/ReadMe.txt: add descriptions of each example
 * all Makefiles: new comments, remove RPMsg library from non-RPMsg projects
 * am65x: Add TX_PRU_CTRL to cmd files
 * TX_PRU_Halt: fix Makefile include_path
 * examples: Remove PRU_ARMtoPRU_Interrupt & PRU_PRUtoARM_Interrupt projects
 * examples/am437x: remove patches folder
 * examples/am65x: fixed date in RTU_Halt
 * labs/Getting_Started_Labs: Remove compiler optimization to make compiled
   firmware disassembly easier to read


v5.9.0
------
Released 2021-09-07

This is the last PSSP release that supports the Linux kernel 5.4 version of the
RemoteProc driver.

Add Release_Notes.txt


v5.8.0
------
Released 2021-03-31

Updated the linker command files so that there is proper alignment for
processors with 64 bit ARM cores (AM65x and j7es, examples & labs).

Updated AM65x Hands_on_Labs cmd files to integrate previous cmd linker file
changes.

Define DCFLAGS in the makefiles that use it (am65x & j7es).


v5.7.0
------
Released 2020-05-01

AM65x examples: replace SUBSYS with more descriptive SLICE in makefiles &
command linker files

Updated AM65x code for AM65x Silicon Revision 2.0 (examples and labs)

Updated software manifest & code to remove GPL-2.0 license

Update header files:
 * Use standard integer types in pru_virtio_ring.h
 * Remove types.h (unused)

READMEs: add link to TRMs


v5.6.0
------
Released 2019-12-16

Updated manifest file from v5.0 --> v6.0 (numbering unrelated to verson number
of PRU Software Support Package)

Added Getting Started Labs
 * Getting Started Labs are for AM335x, AM437x, AM57xx, and AM65xx
 * update labs folder makefiles

Several improvements to examples
 * PRU_gpioToggle toggles all GPO signals by default
 * AM65x examples, add ReadMe file


v5.5.0
------
Released 2019-09-18

Add support for Linux 4.19 with:
vring da field updates: (impacts resource table)
 * Add definition of FW_RSC_ADDR_ANY
 * Update labs & examples to use FW_RSC_ADDR_ANY

add support for j721E by:
	adding a header file for J721E ICSSG INTC
	adding RPMsg examples for J721E PRU & RTU cores
	adding Halt examples for J721E PRU, RTU, & TX_PRU cores

Add clarifying comments to examples:
 * No longer supported: PRU_ARMtoPRU_Interrupt, PRU_PRUtoARM_Interrupt
 * PRU_Hardware_UART: clarify how loopback works
 * ReadMe.txt updated to add new examples & documentation


v5.4.0
------
Released 2018-11-27

examples/am335x/PRU_ADC_onChip did not work out of the box in tag v5.3.0.
Implemented bug fixes.


v5.3.0
------
Released 2018-09-10

Add compatibility w/ Linux Kernel 4.14:
update all resource tables in examples and labs

Expanded hands-on labs:
Expand Linux examples to all supported PRU processors with the introduction of
Lab_0 and the expansion of Lab_5.

AM65x:
* Add ICSSG header files
  - update RPMsg examples to reference header files
* Add examples PRU_Halt, RTU_Halt, PRU_MAC_Multiply_Accum, RTU_MAC_Multiply_Accum
* Fixed typos in linker command files

RPMsg bug fix:
added RPMSG_MESSAGE_SIZE to prevent PRU from sending messages that are too long.
Updated all RPMsg instances in examples and labs.

Rename PRU_ADC to PRU_ADC_onChip


v5.2.1
------
Released 2018-07-24

* Add PRU_ADC example to examples/am335x/PRU_ADC
* bug fixes
  - update RPMsg payload message length from 512 --> 496
  - fix EMCR address in PRU_edmaConfig
  - Update DDR len in Linkr Cmd Files from 0x100 --> 0x10000


v5.2.0
------
Released 2018-07-24

* Add ICSSG INTC resource structure (affects resource table)
* Add AM65x RPMsg examples
* sync up with TI 4.14 kernels
  (updates resource table definitions in include/rsc_types)
* update AM572x SR2.0 PRU UART header file


v5.1.0
------
Released 2016-11-15

*Fixed an incorrect pin mux in the PRU cape dtsi files
  -The PRU UART RTS pin had an incorrect offset which
   caused a conflict with i2c0
  -Reported-by: Gary Thomas <gary@mlbassoc.com>
*Further updated the PRU cape dtsi files to remove pin mux
 conflicts with nodes added in the latest Linux Processor
 SDK
*Fixed an ECAP interrupt issue in the TempSensor Lab/Demo
*Added a Linux demo that allows users to select which PRU
 firmwares they would like to load and run from the console
